---
title: 'XRSystem: isSessionSupported()'
slug: Web/API/XRSystem/isSessionSupported
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Method
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - isSessionSupported
---
<div>{{APIRef("WebXR Device API")}}</div>

<p class="summary"><span class="seoSummary">The {{domxref("XRSystem")}} method <code><strong>isSessionSupported()</strong></code> returns a promise which resolves to <code>true</code> if the specified WebXR session mode is supported by the user's WebXR device. Otherwise, the promise resolves with <code>false</code>.</span></p>

<p class="summary">If the no devices are available or the browser doesn't have permission to use the XR device, the promise is rejected with an appropriate {{domxref("DOMException")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var<em> isSupportedPromise = xr</em>.isSessionSupported(<em>xrSessionMode</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>xrSessionMode</code></dt>
 <dd>A {{domxref("DOMString")}} specifying the WebXR session mode for which support is to be checked. This string must be one of <code>inline</code> (to present the WebXR content inline within the context of an HTML document) or <code>immersive-vr</code> for a fully-immersive virtual experience.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves to <code>true</code> if the specified session mode is supported; otherwise the promise resolves to <code>false</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>Rather than throwing true exceptions, <code>isSessionSupported()</code> rejects the returned promise, passing to the rejection handler a {{domxref("DOMException")}} whose <code>name</code> is one of the following strings.</p>

<dl>
 <dt><code>SecurityError</code></dt>
 <dd>The document's origin does not have permission to use the <code>xr-spatial-tracking</code> <a href="/en-US/docs/Web/HTTP/Feature_Policy">feature policy</a>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In this example, we see <code>isSessionSupported()</code> used to detect whether or not the device supports VR mode by checking to see if an <code>immersive-vr</code> session is supported. If it is, we set up a button to read "Enter XR", to call a method <code>onButtonClicked()</code>, and enable the button.</p>

<p>If no session is already underway, we request the VR session and, if successful, set up the session in a method called <code>onSessionStarted()</code>, not shown. If a session <em>is</em> already underway when the button is clicked, we call the <code>xrSession</code> object's {{domxref("XRSession.end", "end()")}} method to shut down the WebXR session.</p>

<pre class="brush: js notranslate">if (navigator.xr) {
  navigator.xr.isSessionSupported('immersive-vr')
  .then((isSupported) =&gt; {
    if (isSupported) {
      userButton.addEventListener('click', onButtonClicked);
      userButton.textContent = 'Enter XR';
      userButton.disabled = false;
    }
  });
}

function onButtonClicked() {
  if (!xrSession) {
    navigator.xr.requestSession('immersive-vr')
    .then((session) =&gt; {
      xrSession = session;
      // onSessionStarted() not shown for reasons of brevity and clarity.
      onSessionStarted(xrSession);
    });
  } else {
    // Button is a toggle button.
    xrSession.end();
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsystem-issessionsupported","isSessionSupported()")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSystem.isSessionSupported")}}</div>
